; DLL library template
format PE GUI 4.0 DLL
entry DllEntryPoint

include '%finc%/win32/win32a.inc'

struc db [data]
  {
        common
        . db data
        .size = $ - .
  }


; Description of the binary;
; NOTE: those are Unicode strings, and they get placed in the .rsrc section
; However, the null terminator must be omitted

Comments                equ     'Implements a nonexistent display adapter which declares itself as a 3D-capable device, but discards all of the data without rendering any of it to the screen.'
CompanyName             equ     'Mechanist'
FileDescription         equ     'NULL renderer for Drakan dedicated server'
LegalCopyright          equ     'Copyright ',0A9h,' 2018 Mechanist'
ProductName             equ     'Drakan Community Patch'



section '.code' code readable executable notpageable

include 'NullRndr_DLL_Entry.asm'

include 'NullRndr_Functions.asm'



section '.data' data readable writeable notpageable

        szDriverName0      db 'NULL renderer (without display output!)',0

align 4

        GUID_0             dd 4 dup 0                           ; the GUID is 16 bytes long

        pDDRAW             dd DDRAW
        pDDRAW4            dd DDRAW
        pDDRAWCLIPPER      dd DDRAWCLIPPER
        pDDRAWPALETTE      dd DDRAWPALETTE
        pDDRAWSURFACE      dd DDRAWSURFACE
        pDIRECT3D3         dd DIRECT3D3

DDRAW:

        DD_00h             dd QueryInterface
        DD_04h             dd AddRef
        DD_08h             dd Release
        DD_0Ch             dd Unimplemented
        DD_10h             dd DDRAW_CreateClipper
        DD_14h             dd DDRAW_CreatePalette
        DD_18h             dd DDRAW_CreateSurface
        DD_1Ch             dd Unimplemented
        DD_20h             dd DDRAW_EnumDisplayModes
        DD_24h             dd Unimplemented
        DD_28h             dd Unimplemented
        DD_2Ch             dd DDRAW_GetCaps
        DD_30h             dd DDRAW_GetDisplayMode
        DD_34h             dd Unimplemented
        DD_38h             dd Unimplemented
        DD_3Ch             dd Unimplemented
        DD_40h             dd Unimplemented
        DD_44h             dd Unimplemented
        DD_48h             dd Unimplemented
        DD_4Ch             dd Unimplemented
        DD_50h             dd DDRAW_SetCooperativeLevel
        DD_54h             dd Unimplemented
        DD_58h             dd Unimplemented
        DD_5Ch             dd Unimplemented
        DD_60h             dd Unimplemented
        DD_64h             dd Unimplemented
        DD_68h             dd Unimplemented
        DD_6Ch             dd DDRAW_GetDeviceIdentifier

DDRAWCLIPPER:

        DDC_00h            dd QueryInterface
        DDC_04h            dd AddRef
        DDC_08h            dd Release
        DDC_0Ch            dd Unimplemented
        DDC_10h            dd Unimplemented
        DDC_14h            dd Unimplemented
        DDC_18h            dd Unimplemented
        DDC_1Ch            dd Unimplemented
        DDC_20h            dd DDRAW_SetCooperativeLevel         ; DDRAWCLIPPER_SetHWnd

DDRAWPALETTE:

        DDP_00h            dd QueryInterface
        DDP_04h            dd AddRef
        DDP_08h            dd Release
        DDP_0Ch            dd DDRAWPALETTE_GetCaps
        DDP_10h            dd Unimplemented
        DDP_14h            dd Unimplemented
        DDP_18h            dd DDRAWPALETTE_SetEntries

DDRAWSURFACE:

        DDS_00h            dd QueryInterface
        DDS_04h            dd AddRef
        DDS_08h            dd Release
        DDS_0Ch            dd Unimplemented
        DDS_10h            dd Unimplemented
        DDS_14h            dd DDRAWSURFACE_Blt
        DDS_18h            dd Unimplemented
        DDS_1Ch            dd Unimplemented
        DDS_20h            dd Unimplemented
        DDS_24h            dd Unimplemented
        DDS_28h            dd Unimplemented
        DDS_2Ch            dd Unimplemented
        DDS_30h            dd Unimplemented
        DDS_34h            dd Unimplemented
        DDS_38h            dd Unimplemented
        DDS_3Ch            dd Unimplemented
        DDS_40h            dd Unimplemented
        DDS_44h            dd Unimplemented
        DDS_48h            dd Unimplemented
        DDS_4Ch            dd Unimplemented
        DDS_50h            dd Unimplemented
        DDS_54h            dd Unimplemented
        DDS_58h            dd DDRAW_GetDisplayMode              ; actually it's DDRAWSURFACE_GetSurfaceDesc - but the method is identical, so it can be reused
        DDS_5Ch            dd Unimplemented
        DDS_60h            dd Unimplemented
        DDS_64h            dd DDRAWPALETTE_SetEntries           ; DDRAWSURFACE_Lock
        DDS_68h            dd Unimplemented
        DDS_6Ch            dd Unimplemented
        DDS_70h            dd DDRAWSURFACE_SetClipper
        DDS_74h            dd Unimplemented
        DDS_78h            dd Unimplemented
        DDS_7Ch            dd Unimplemented
        DDS_80h            dd DDRAWSURFACE_SetClipper           ; DDRAWSURFACE_Unlock
        DDS_84h            dd Unimplemented
        DDS_88h            dd Unimplemented
        DDS_8Ch            dd Unimplemented

DIRECT3D3:

        DIRECT3D3_00h      dd QueryInterface
        DIRECT3D3_04h      dd AddRef
        DIRECT3D3_08h      dd Release
        DIRECT3D3_0Ch      dd D3D3_EnumDevices
        DIRECT3D3_10h      dd Unimplemented
        DIRECT3D3_14h      dd Unimplemented
        DIRECT3D3_18h      dd Unimplemented
        DIRECT3D3_1Ch      dd Unimplemented
        DIRECT3D3_20h      dd Unimplemented
        DIRECT3D3_24h      dd Unimplemented
        DIRECT3D3_28h      dd D3D3_EnumZBufferFormats
        DIRECT3D3_2Ch      dd Unimplemented

DDDEVICEIDENTIFIER:

        DDDEVICEIDENTIFIER_szDriver                     db 'NULL renderer (without display output!)',0
        DDDEVICEIDENTIFIER_szDescription                db 'NULL renderer (without display output!)',0
        DDDEVICEIDENTIFIER_liDriverVersion              dq 0
        DDDEVICEIDENTIFIER_dwVendorId                   dd 0
        DDDEVICEIDENTIFIER_dwDeviceId                   dd 0
        DDDEVICEIDENTIFIER_dwSubSysId                   dd 0
        DDDEVICEIDENTIFIER_dwRevision                   dd 0
        DDDEVICEIDENTIFIER_guidDeviceIdentifier         dd 4 dup 0

DDDEVICEIDENTIFIER_END:

DDPIXELFORMAT:

        DDPIXELFORMAT_dwSize                            dd 20h
        DDPIXELFORMAT_dwFlags                           dd 0
        DDPIXELFORMAT_dwFourCC                          dd 0
        DDPIXELFORMAT_dwZBufferBitDepth                 dd 20h
        DDPIXELFORMAT_dwStencilBitDepth                 dd 8
        DDPIXELFORMAT_dwZBitMask                        dd 0FFFh
        DDPIXELFORMAT_dwStencilBitMask                  dd 0F000h
        DDPIXELFORMAT_dwRGBZBitMask                     dd 0

DDSURFACEDESC:

        DDSURFACEDESC_dwSize                            dd 6Ch
        DDSURFACEDESC_dwFlags                           dd 41006h       ; width, height, refresh rate, pixel format
        DDSURFACEDESC_dwHeight                          dd 480
        DDSURFACEDESC_dwWidth                           dd 640
        DDSURFACEDESC_lPitch                            dd 1
        DDSURFACEDESC_dwBackBufferCount                 dd 0
        DDSURFACEDESC_dwRefreshRate                     dd 60
        DDSURFACEDESC_dwAlphaBitDepth                   dd 0
        DDSURFACEDESC_dwReserved                        dd 0
        DDSURFACEDESC_lpSurface                         dd 0
        DDSURFACEDESC_ColorKeyGarbage                   dd 8 dup 0
        DDSURFACEDESC_DDPIXELFORMAT_dwSize              dd 20h
        DDSURFACEDESC_DDPIXELFORMAT_dwFlags             dd 40h          ; DDPF_RGB
        DDSURFACEDESC_DDPIXELFORMAT_dwFourCC            dd 0
        DDSURFACEDESC_DDPIXELFORMAT_dwRGBBitCount       dd 20h          ; bits per pixel
        DDSURFACEDESC_DDPIXELFORMAT_dwRBitMask          dd 0
        DDSURFACEDESC_DDPIXELFORMAT_dwGBitMask          dd 0
        DDSURFACEDESC_DDPIXELFORMAT_dwBBitMask          dd 0
        DDSURFACEDESC_DDPIXELFORMAT_dwRGBAlphaBitMask   dd 0
        DDSURFACEDESC_dwCaps                            dd 0

D3DDEVICEDESC:

        D3DDEVICEDESC_dwSize                            dd 0ACh
        D3DDEVICEDESC_dwFlags                           dd 81h          ; dcmColorModel and dwDeviceRenderBitDepth is valid
        D3DDEVICEDESC_dcmColorModel                     dd 2            ; D3DCOLOR_RGB
        D3DDEVICEDESC_dwDevCaps                         dd 0
        D3DDEVICEDESC_dtcTransformCaps_dwSize           dd 8
        D3DDEVICEDESC_dtcTransformCaps_dwCaps           dd 0
        D3DDEVICEDESC_bClipping                         dd 0
        D3DDEVICEDESC_dlcLightingCaps_dwSize            dd 10h
        D3DDEVICEDESC_dlcLightingCaps_dwCaps            dd 0
        D3DDEVICEDESC_dlcLightingCaps_dwLightingModel   dd 0
        D3DDEVICEDESC_dlcLightingCaps_dwNumLights       dd 0
        D3DDEVICEDESC_dpcLineCaps_dwSize                dd 38h
        D3DDEVICEDESC_dpcLineCaps_dwMiscCaps            dd 0
        D3DDEVICEDESC_dpcLineCaps_dwRasterCaps          dd 0
        D3DDEVICEDESC_dpcLineCaps_dwZCmpCaps            dd 0
        D3DDEVICEDESC_dpcLineCaps_dwSrcBlendCaps        dd 0
        D3DDEVICEDESC_dpcLineCaps_dwDestBlendCaps       dd 0
        D3DDEVICEDESC_dpcLineCaps_dwAlphaCmpCaps        dd 0
        D3DDEVICEDESC_dpcLineCaps_dwShadeCaps           dd 0
        D3DDEVICEDESC_dpcLineCaps_dwTextureCaps         dd 0Ch          ; supports alpha component + colorkeyed textures
        D3DDEVICEDESC_dpcLineCaps_dwTextureFilterCaps   dd 0
        D3DDEVICEDESC_dpcLineCaps_dwTextureBlendCaps    dd 0
        D3DDEVICEDESC_dpcLineCaps_dwTextureAddressCaps  dd 0
        D3DDEVICEDESC_dpcLineCaps_dwStippleWidth        dd 0
        D3DDEVICEDESC_dpcLineCaps_dwStippleHeight       dd 0
        D3DDEVICEDESC_dpcTriCaps_dwSize                 dd 38h
        D3DDEVICEDESC_dpcTriCaps_dwMiscCaps             dd 0
        D3DDEVICEDESC_dpcTriCaps_dwRasterCaps           dd 0
        D3DDEVICEDESC_dpcTriCaps_dwZCmpCaps             dd 0
        D3DDEVICEDESC_dpcTriCaps_dwSrcBlendCaps         dd 0
        D3DDEVICEDESC_dpcTriCaps_dwDestBlendCaps        dd 0
        D3DDEVICEDESC_dpcTriCaps_dwAlphaCmpCaps         dd 0
        D3DDEVICEDESC_dpcTriCaps_dwShadeCaps            dd 0
        D3DDEVICEDESC_dpcTriCaps_dwTextureCaps          dd 0Ch          ; supports alpha component + colorkeyed textures
        D3DDEVICEDESC_dpcTriCaps_dwTextureFilterCaps    dd 0
        D3DDEVICEDESC_dpcTriCaps_dwTextureBlendCaps     dd 0
        D3DDEVICEDESC_dpcTriCaps_dwTextureAddressCaps   dd 0
        D3DDEVICEDESC_dpcTriCaps_dwStippleWidth         dd 0
        D3DDEVICEDESC_dpcTriCaps_dwStippleHeight        dd 0
        D3DDEVICEDESC_dwDeviceRenderBitDepth            dd 32
        D3DDEVICEDESC_dwDeviceZBufferBitDepth           dd 32
        D3DDEVICEDESC_dwMaxBufferSize                   dd 0
        D3DDEVICEDESC_dwMaxVertexCount                  dd 0
        D3DDEVICEDESC_dummy                             dd 22 dup 0     ; needed because the Riot Engine expects to get the D3D6 struct (which is longer), despite asking for the RIID of D3D3...



section '.rsrc' resource data readable notpageable

include 'Resources_section_kludge.asm'



section '.idata' import data readable notpageable

  library Kernel32,'KERNEL32.DLL'

  import  Kernel32,\
          DisableThreadLibraryCalls, 'DisableThreadLibraryCalls'



section '.edata' export data readable notpageable

  export 'DDRAW.DLL',\
         DirectDrawCreate, 'DirectDrawCreate',\
         DirectDrawEnumerateA, 'DirectDrawEnumerateA',\
         DirectDrawEnumerateExA, 'DirectDrawEnumerateExA'



section '.reloc' fixups data readable notpageable discardable

  ; Fixup section. You don't have to
  ; put anything here manually.