; Null renderer code for the NullRndr.dll

;---- dummy function - trap for unimplemented methods ----
Unimplemented:

        ud2


;--------------- IUNKNOWN functions ----------------------
proc QueryInterface, .hDDRAW, .riid, .ppvObject
begin

        mov     eax,80004003h                                   ; HRESULT = E_POINTER
        mov     ecx,[.ppvObject]

        test    ecx,ecx
        jz      .fail

        mov     eax,80004002h                                   ; HRESULT = E_NOINTERFACE
        mov     edx,[.riid]
        cmp     DWORD [edx],9C59509Ah                           ; IDirectDraw4 interface
        jz      .DDRAW4

        cmp     DWORD [edx],0BB223240h                          ; IDirect3D3 interface
        jz      .DIRECT3D3

        jmp     .fail

.DDRAW4:

        mov     DWORD [ecx],pDDRAW4

        jmp     .exit

.DIRECT3D3:

        mov     DWORD [ecx],pDIRECT3D3

.exit:

        xor     eax,eax                                         ; return DD_OK

.fail:

        return
endp


AddRef:

        mov     eax,1

        retn    4


Release:

        xor     eax,eax                                         ; return DD_OK

        retn    4


;--------------- DDRAW functions ----------------------
DDRAW_CreateClipper:
;proc DDRAW_CreateClipper, .hDDRAW, .dwFlags, .lplpDDClipper, .pUnkOuter
;begin

        mov     eax,[esp + 0Ch]
        mov     DWORD [eax],pDDRAWCLIPPER

        xor     eax,eax

        retn    10h

;endp


DDRAW_CreatePalette:
;proc DDRAW_CreatePalette, .hDDRAW, .dwFlags, .lpColorTable, .lplpDDPalette, .pUnkOuter
;begin

        mov     eax,[esp + 10h]
        mov     DWORD [eax],pDDRAWPALETTE

        xor      eax,eax

        retn    14h

;endp


DDRAW_CreateSurface:
;proc DDRAW_CreateSurface, .hDDRAW, .lpDDSurfaceDesc, .lplpDDSurface, .pUnkOuter
;begin

        mov     eax,[esp + 0Ch]
        mov     DWORD [eax],pDDRAWSURFACE

        xor      eax,eax

        retn    10h

;endp


DDRAW_EnumDisplayModes:
;proc DDRAW_EnumDisplayModes, .hDDRAW, .dwFlags, .lpDDSurfaceDesc, .lpContext, .lpEnumCallback
;begin

        push    esi

        mov     esi,4

        mov     [DDSURFACEDESC_DDPIXELFORMAT_dwRGBBitCount],0

.loop:                                                          ; enumerate all of the possible bits-per-pixel modes (8...32)

        dec     esi

        add     [DDSURFACEDESC_DDPIXELFORMAT_dwRGBBitCount],8

        push    DWORD [esp + 14h]
        push    DDSURFACEDESC                                   ; push the pointer, NOT the value!

        call    DWORD [esp + 20h]

        test    eax,eax                                         ; did the callback function request to stop the enumeration?
        jz      .exit

        test    esi,esi
        jnz     .loop

.exit:

        pop     esi

        xor     eax,eax                                         ; return DD_OK

        retn    14h

;endp


DDRAW_GetCaps:
;proc DDRAW_GetCaps, .hDDRAW, .lpDDDriverCaps, .lpDDHELCaps
;begin

        mov     edx,[esp + 8]

        mov     eax,80070006h                                   ; return DDERR_INVALIDPARAMS
        test    edx,edx
        jz      .exit

        mov     [edx + 4],DWORD 1                               ; DDCAPS: device is 3D-capable
        mov     [edx + 8],DWORD 80000h                          ; DDCAPS2: device can render in windowed mode

        xor     eax,eax                                         ; return DD_OK

.exit:

        retn    0Ch

;endp


DDRAW_GetDisplayMode:
;proc DDRAW_GetDisplayMode, .hDDRAW, .lpDDSurfaceDesc
;begin

        push    esi

        mov     ecx,[DDSURFACEDESC_dwSize]
        shr     ecx,2

        mov     edx,[esp + 0Ch]

        mov     esi,DDSURFACEDESC

        mov     [DDSURFACEDESC_DDPIXELFORMAT_dwRGBBitCount],20h ; report 32 bits per pixel

.loop:

        mov     eax,[esi + ecx * 4 - 4]
        mov     [edx + ecx * 4 - 4],eax

        loop    .loop

        pop     esi

        xor     eax,eax                                         ; return DD_OK

        retn    8

;endp


DDRAW_SetCooperativeLevel:
;proc DDRAW4_SetCooperativeLevel, .hDDRAW, .hWnd, .dwFlags
;begin

        xor     eax,eax

        retn    0Ch

;endp


DDRAW_GetDeviceIdentifier:
;proc DDRAW4_GetDeviceIdentifier, .hDDRAW, .lpDDDeviceIdentifier, .dwFlags
;begin

        pushad

        mov     esi,DDDEVICEIDENTIFIER
        mov     edi,[esp + 28]

        mov     ecx,(DDDEVICEIDENTIFIER_END - DDDEVICEIDENTIFIER)

        rep     movsb

        popad

        xor     eax,eax

        retn    0Ch

;endp


;--------------- DDRAWCLIPPER functions ----------------------
;DDRAWCLIPPER_SetHWnd:
;proc DDRAWCLIPPER_SetHWnd, .hDDRAWCLIPPER, .dwFlags, .hWnd
;begin

;        xor     eax,eax

;        retn    0Ch

;endp

;--------------- DDRAWPALETTE functions ----------------------
DDRAWPALETTE_GetCaps:
;proc DDRAWPALETTE_GetCaps, .hDDRAWPALETTE, .lpdwCaps
;begin

        mov     eax,[esp + 8]
        mov     [eax],DWORD 54h                                 ; DDPCAPS_8BIT || DDPCAPS_PRIMARYSURFACE || DDPCAPS_ALLOW256

        xor     eax,eax                                         ; return DD_OK

        retn    8

;endp


DDRAWPALETTE_SetEntries:
;proc DDRAWPALETTE_SetEntries, .hDDRAWPALETTE, .dwFlags, .dwStartingEntry, .dwCount, .lpEntries
;begin

        xor     eax,eax                                         ; return DD_OK

        retn    14h

;endp


;--------------- DDRAWSURFACE functions ----------------------
DDRAWSURFACE_Blt:
;proc DDRAWSURFACE_Blt, .hDDSURFACE, .lpDestRect, .lpDDSrcSurface, .lpSrcRect, .dwFlags, .lpDDBltFX
;begin

        xor     eax,eax

        retn    18h

;endp


;DDRAWSURFACE_Lock:
;proc DDRAWSURFACE_Lock, .hDDSURFACE, .lpDestRect, .lpDDSurfaceDesc, .dwFlags, .hEvent
;begin

;        xor     eax,eax

;        retn    14h

;endp


DDRAWSURFACE_SetClipper:
;proc DDRAWSURFACE_SetClipper, .hDDSURFACE, .lpDDClipper
;begin

        xor     eax,eax

        retn    8

;endp


;DDRAWSURFACE_Unlock:
;proc DDRAWSURFACE_Unlock, .hDDSURFACE, .lpSurfaceData
;begin

;        xor     eax,eax

;        retn    8

;endp


;--------------- DIRECT3D3 functions ----------------------
D3D3_EnumDevices:
;proc D3D3_EnumDevices, .hD3D, .lpD3DEnumDevicesCallback, .lpUserArg
;begin

        push    esi

        mov     esi,4

        mov     [D3DDEVICEDESC_dwDeviceRenderBitDepth],0

.loop:                                                          ; enumerate all of the possible bits-per-pixel modes (8...32)

        dec     esi

        add     [D3DDEVICEDESC_dwDeviceRenderBitDepth],8

        push    DWORD [esp + 10h]
        push    D3DDEVICEDESC                                   ; push the pointer, NOT the value!
        push    D3DDEVICEDESC                                   ; push the pointer, NOT the value!
        push    szDriverName0
        push    szDriverName0
        push    GUID_0                                          ; push the pointer, NOT the value!

        call    DWORD [esp + 24h]

        test    eax,eax                                         ; did the callback function request to stop the enumeration?
        jz      .exit

        test    esi,esi
        jnz     .loop

.exit:

        pop     esi

        xor     eax,eax                                         ; return DD_OK

        retn    0Ch

;endp


D3D3_EnumZBufferFormats:
;proc D3D3_EnumZBufferFormats, .hD3D, .lpDevice, .lpD3DEnumPixelFormatsCallback, .lpContext
;begin

        push    DWORD [esp + 10h]
        push    DDPIXELFORMAT                                   ; push the pointer, NOT the value!

        call    DWORD [esp + 14h]

        xor     eax,eax                                         ; return DD_OK

        retn    10h

;endp


;--------------- export functions ----------------------
align 4                                                         ; the alignment is theoretically not needed, but not doing this could cause unpredictable compatibility issues
DirectDrawCreate:
;proc DirectDrawCreate, .lpGuid, .lplpDD, .pUnkOuter
;begin

        mov     eax,[esp + 8]
        mov     DWORD [eax],pDDRAW

        xor     eax,eax

        retn    0Ch

;endp


align 4
DirectDrawEnumerateA:
;proc DirectDrawEnumerateA, .lpDDEnumCallback, .lpContext
;begin

        push    DWORD [esp + 8]
        push    szDriverName0
        push    szDriverName0
        push    GUID_0                                          ; push the pointer, NOT the value!

        call    DWORD [esp + 14h]                               ; enumerate only a single (fake) driver

        xor     eax,eax

        retn    8

;endp


align 4
DirectDrawEnumerateExA:
;proc DirectDrawEnumerateExA, .lpDDEnumCallback, .lpContext, .dwFlags
;begin

        push    DWORD [esp + 8]
        push    szDriverName0
        push    szDriverName0
        push    GUID_0                                          ; push the pointer, NOT the value!

        call    DWORD [esp + 14h]                               ; enumerate only a single (fake) driver

        xor     eax,eax

        retn    0Ch

;endp